<!--
    Original overlay code and implementation by SimpleAOB
    Contact:
        Discord - SimpleAOB#9999 (preferred)
        Email - simple(@at)bakkesplugins(dot)com
    Credits:
        Default images and guidance on art by RJsaurus - https://twitter.com/deeposaurus
        BakkesWebApi by gboddin - Heavily modified and extended by SimpleAOB
            - Now available at: https://gitlab.com/bakkesplugins/sos/sos-plugin
-->

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>SOS - Rocket League OBS Browser Source Overlay</title>
    <style>
        ${require('../out/css/main.min.css')}
    </style>
</head>
<body>
    <div class="page-container">
        <div class="waiting-for-websocket">
            <div class="technical-difficulties hidden"></div>
            <div class="text">
                Waiting for Websocket Server to connect...
            </div>
        </div>
    </div>
    <video class="background-video" src="assets/CC_Plexus BG_001.mp4" loop></video>
    <div class="up-next">
        <div class="vs-graphic"><img src="assets/covert_up_next_vs.png"></div>
        <div class="team left">
            <div class="name">Cloud9</div>
            <div class="player-1">
                <div class="player-background"></div>
                <div class="player-name">asdasd</div>
            </div>
            <div class="player-2">
                <div class="player-background"></div>
                <div class="player-name">asdasd</div>
            </div>
            <div class="player-3">
                <div class="player-background"></div>
                <div class="player-name">asdasd</div>
            </div>
            <div class="colored-rectangle" style="background-color: #0090d3; box-shadow: 20px 0 600px 300px #0090d3, -20px -16px 600px 300px #0090d3;"></div>
            <div class="logo"><img></div>
        </div>
        <div class="team right">
            <div class="name"></div>
            <div class="player-1">
                <div class="player-background"></div>
                <div class="player-name">asdasd</div>
            </div>
            <div class="player-2">
                <div class="player-background"></div>
                <div class="player-name">asdasd</div>
            </div>
            <div class="player-3">
                <div class="player-background"></div>
                <div class="player-name">asdasd</div>
            </div>
            <div class="colored-rectangle" style="background-color: #f26522; box-shadow: 20px 0px 600px 300px #f26522, -20px -16px 600px 300px #f26522;"></div>
            <div class="logo"><img></div>
        </div>
    </div>
    <script>${require('vendor/jquery-3.4.1/jquery-3.4.1.min.js')}</script>
    <script>${require('../out/js/base.js')}</script>
    <script>
        //!!! Register the websocket listeners before attempting to connect
        WsSubscribers.subscribe("ws", "open", function() {
            $(".waiting-for-websocket").addClass("hidden");
            WsSubscribers.send("cb", "first_connect", {
                'name': 'RosterUpNext',
                'version': ${require('../version.txt')}
            });
            setInterval(function () {
                WsSubscribers.send("cb", "heartbeat", "heartbeat");
            }, 1000);
        });

        WsSubscribers.subscribe("ws", "open", function() {
            $(".waiting-for-websocket").addClass("hidden");
        });

        WsSubscribers.subscribe("ws", "error", function() {
            $(".waiting-for-websocket .text").text("[002] There has been an error with the Rocket League connection. Please stand by");
            $(".waiting-for-websocket").removeClass("hidden");
        });

        WsSubscribers.subscribe("ws", "close", function() {
            $(".waiting-for-websocket .text").text("[004] Connection to Rocket League has gone away. Please stand by");
            $(".waiting-for-websocket, .technical-difficulties").removeClass("hidden");
        });

        WsSubscribers.init(49322, false, [
            "game:update_tick",
            "cb:heartbeat"
        ]);
    </script>
    <script>
        $(() => {
            $('body').one('click', () => {
               $('.background-video')[0].play();
            });
            $('.player-background').html(`
                    <svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" width="368px" height="72px">
                        <style type="text/css">
                            .st0{
                                /*backdrop-filter: blur(30px);*/
                                fill: #1d1d1d;
                            }
                        </style>
                        <rect class="st0" width="368" height="72"/>
                    </svg>
                `);
        });

        let teamMap = ${require('../../team_logos/map.json')};
        WsSubscribers.subscribe("sos", "up_next_teams_update", (d) => {
            let leftLower = d.left.name.toLowerCase();
            let rightLower = d.right.name.toLowerCase();

            let colorShadowBase = `20px 0px 600px 300px ##COLOR##, -20px -16px 600px 300px ##COLOR##`;

            if (teamMap.hasOwnProperty(leftLower)) {
                let teamLeft = teamMap[leftLower];
                $('.team.left .logo img').attr('src', `../team_logos/${teamLeft.logo}`);
                $('.team.left .colored-rectangle').css('background-color', teamLeft.background).css('box-shadow', colorShadowBase.replace(/##COLOR##/g, teamLeft.background));
                console.log(colorShadowBase.replace(/##CLOLOR##/g, teamLeft.background));
            } else {
                $('.team.left .logo img').attr('src', `../team_logos/DEFAULT.png`);
                $('.team.left .colored-rectangle').css('background-color', '#0090d3').css('box-shadow', colorShadowBase.replace(/##COLOR##/g, '#0090d3'));
            }

            if (teamMap.hasOwnProperty(rightLower)) {
                let teamRight = teamMap[rightLower];
                $('.team.right .logo img').attr('src', `../team_logos/${teamRight.logo}`);
                $('.team.right .colored-rectangle').css('background-color', teamRight.background).css('box-shadow', colorShadowBase.replace(/##COLOR##/g, teamRight.background));
            } else {
                $('.team.right .logo img').attr('src', `../team_logos/DEFAULT.png`);
                $('.team.right .colored-rectangle').css('background-color', '#f26522').css('box-shadow', colorShadowBase.replace(/##COLOR##/g, '#f26522'));
            }

            $('.team.left .name').text(d.left.name);
            $('.team.right .name').text(d.right.name);

            $('.team.left .player-1 .player-name').text(d.left.players.one.name);
            $('.team.left .player-2 .player-name').text(d.left.players.two.name);
            $('.team.left .player-3 .player-name').text(d.left.players.three.name);

            $('.team.right .player-1 .player-name').text(d.right.players.one.name);
            $('.team.right .player-2 .player-name').text(d.right.players.two.name);
            $('.team.right .player-3 .player-name').text(d.right.players.three.name);

            SOSUtils.fitText('.team .name', 45);
            SOSUtils.fitText('.player-name', 37);
        });
    </script>
    <script>${require('sos-plugins/testing/js/testing.js')}</script>
</body>
</html>